global function ScoreboardNameHandlerInit

const int Base = 11
const int MOD = 9997

const int InitialHash = 0

struct{
    table<string, string> cache
    } file


void function ScoreboardNameHandlerInit(){
    thread Monitor()
}


void function Monitor(){
    WaitFrame()

    SetScoreboardUpdateCallback(replaceScoreboard)
}

string function GetNameMode()
{
    return strip(GetConVarString("mp_scoreboard_name_mode")).tolower();
}

string function GetTagMode()
{
    return strip(GetConVarString("mp_scoreboard_tag_mode")).tolower();
}

string function GetPlaceholder()
{
    return strip(GetConVarString("mp_scoreboard_placeholder")).tolower();
}


string function GetPrefix() {
    return strip(GetConVarString("mp_scoreboard_name_prefix")).tolower();
}

string function GetCustomTag()
{
    return strip(GetConVarString("mp_scoreboard_custom_tag")).tolower();
}

bool function ShouldReplaceIcon() {
    return strip(GetConVarString("mp_scoreboard_replace_icon")).tolower() == "true" ? true : false;
}

// replace the scoreboard
// GetPlayerName() 不会获取到玩家的Ctag
void function replaceScoreboard(entity e, var rui)
{
    if (!e.IsPlayer())
        return;

    entity player = GetLocalClientPlayer();
    string name = e.GetPlayerNameWithClanTag();
    name = HashNameWithTag(name);


    RuiSetString(rui, "playerName", name)
    // Patch
    if (ShouldReplaceIcon())
        RuiSetImage (rui, "playerCard", CallsignIcon_GetSmallImage( PlayerCallsignIcon_GetActive( player ) ) )
}



string function HashNameWithTag(string name)
{
    array<string> resultSplit = split(name, "[]");
    string ctag = "";
    if (resultSplit.len() > 1) {
        name = strip(resultSplit[resultSplit.len() - 1])
        ctag = strip(resultSplit[0])
        // print("strip resultSplit[resultSplit.len() - 1] " + name)
        // print("strip resultSplit[0] " + ctag)
    }
        if (name in file.cache) {
            name = file.cache[name]
        }
        else
        {
            string originalName = name;
            switch(GetNameMode())
            {
                case "digital":
                    name = _Rand(name)
                    break
                case "replace":
                    name = GetPlaceholder()
                    break
                case "apexlike":
                    name = HashToApexlike(name)
                    break
                default:
                    break;
            }
            file.cache[originalName] <- name;
        }




    // print("hashName Hashed" + name)

    name = getTag(ctag) + name
    return strip(name);
}

// 获取玩家应该得到的Tag
string function getTag(string tag)
{
    tag = strip(tag)
    switch (GetTagMode()) {
        case "adv":
            tag = "[ADV] ";
            break;
        case "empty":
            tag = "";
            break;
        case "custom":
            tag = "[" + GetCustomTag() + "] ";
            break;
        default:
            tag = tag == "" ? "" : "[" + tag + "] ";
            break;
    }
    return tag
}

// rand int
string function _Rand(string name)
{
    return string(rand())
}

string function HashToApexlike(string name)
{
    return GetPrefix() + _Rand(name)
}